## fio 3.28

=== Makefile ===
ifeq ($(SRCDIR),)
SRCDIR := .
endif

VPATH := $(SRCDIR)

all: fio

config-host.mak: configure
	@if [ ! -e "$@" ]; then					\
	  echo "Running configure ...";				\
	  ./configure;						\
	else							\
	  echo "$@ is out-of-date, running configure";		\
	  sed -n "/.*Configured with/s/[^:]*: //p" "$@" | sh;	\
	fi

ifneq ($(MAKECMDGOALS),clean)
include config-host.mak
endif

DEBUGFLAGS = -DFIO_INC_DEBUG
CPPFLAGS= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -DFIO_INTERNAL $(DEBUGFLAGS)
OPTFLAGS= -g -ffast-math
FIO_CFLAGS= -std=gnu99 -Wwrite-strings -Wall -Wdeclaration-after-statement $(OPTFLAGS) $(EXTFLAGS) $(BUILD_CFLAGS) -I. -I$(SRCDIR)
LIBS	+= -lm $(EXTLIBS)
PROGS	= fio
SCRIPTS = $(addprefix $(SRCDIR)/,tools/fio_generate_plots tools/plot/fio2gnuplot tools/genfio tools/fiologparser.py tools/hist/fiologparser_hist.py tools/hist/fio-histo-log-pctiles.py tools/fio_jsonplus_clat2csv)

ifndef CONFIG_FIO_NO_OPT
  FIO_CFLAGS += -O3 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
endif
ifdef CONFIG_BUILD_NATIVE
  FIO_CFLAGS += -march=native
endif

ifdef CONFIG_PDB
  LINK_PDBFILE ?= -Wl,-pdb,$(dir $@)/$(basename $(@F)).pdb
  FIO_CFLAGS += -gcodeview
  LDFLAGS += -fuse-ld=lld $(LINK_PDBFILE)
endif

# If clang, do not use builtin stpcpy as it breaks the build
ifeq ($(CC),clang)
  FIO_CFLAGS += -fno-builtin-stpcpy
endif

ifdef CONFIG_GFIO
  PROGS += gfio
endif

SOURCE :=	$(sort $(patsubst $(SRCDIR)/%,%,$(wildcard $(SRCDIR)/crc/*.c)) \
		$(patsubst $(SRCDIR)/%,%,$(wildcard $(SRCDIR)/lib/*.c))) \
		gettime.c ioengines.c init.c stat.c log.c time.c filesetup.c \
		eta.c verify.c memory.c io_u.c parse.c fio_sem.c rwlock.c \
		pshared.c options.c \
		smalloc.c filehash.c profile.c debug.c engines/cpu.c \
		engines/mmap.c engines/sync.c engines/null.c engines/net.c \
		engines/ftruncate.c engines/filecreate.c engines/filestat.c engines/filedelete.c \
		engines/exec.c \
		server.c client.c iolog.c backend.c libfio.c flow.c cconv.c \
		gettime-thread.c helpers.c json.c idletime.c td_error.c \
		profiles/tiobench.c profiles/act.c io_u_queue.c filelock.c \
		workqueue.c rate-submit.c optgroup.c helper_thread.c \
		steadystate.c zone-dist.c zbd.c dedupe.c

ifdef CONFIG_LIBHDFS
  HDFSFLAGS= -I $(JAVA_HOME)/include -I $(JAVA_HOME)/include/linux -I $(FIO_LIBHDFS_INCLUDE)
  HDFSLIB= -Wl,-rpath $(JAVA_HOME)/lib/$(FIO_HDFS_CPU)/server -L$(JAVA_HOME)/lib/$(FIO_HDFS_CPU)/server $(FIO_LIBHDFS_LIB)/libhdfs.a -ljvm
  FIO_CFLAGS += $(HDFSFLAGS)
  SOURCE += engines/libhdfs.c
endif

ifdef CONFIG_LIBISCSI
  libiscsi_SRCS = engines/libiscsi.c
  libiscsi_LIBS = $(LIBISCSI_LIBS)
  libiscsi_CFLAGS = $(LIBISCSI_CFLAGS)
  ENGINES += libiscsi
endif

ifdef CONFIG_LIBNBD
  nbd_SRCS = engines/nbd.c
  nbd_LIBS = $(LIBNBD_LIBS)
  nbd_CFLAGS = $(LIBNBD_CFLAGS)
  ENGINES += nbd
endif

ifdef CONFIG_LIBNFS
  CFLAGS += $(LIBNFS_CFLAGS)
  LIBS += $(LIBNFS_LIBS)
  SOURCE += engines/nfs.c
endif

ifdef CONFIG_64BIT
  CPPFLAGS += -DBITS_PER_LONG=64
else ifdef CONFIG_32BIT
  CPPFLAGS += -DBITS_PER_LONG=32
endif
ifdef CONFIG_LIBAIO
  libaio_SRCS = engines/libaio.c
  libaio_LIBS = -laio
  ENGINES += libaio
endif
ifdef CONFIG_RDMA
  rdma_SRCS = engines/rdma.c
  rdma_LIBS = -libverbs -lrdmacm
  ENGINES += rdma
endif
ifdef CONFIG_LIBRPMA_APM
  librpma_apm_SRCS = engines/librpma_apm.c
  librpma_fio_SRCS = engines/librpma_fio.c
  librpma_apm_LIBS = -lrpma -lpmem
  ENGINES += librpma_apm
endif
ifdef CONFIG_LIBRPMA_GPSPM
  librpma_gpspm_SRCS = engines/librpma_gpspm.c engines/librpma_gpspm_flush.pb-c.c
  librpma_fio_SRCS = engines/librpma_fio.c
  librpma_gpspm_LIBS = -lrpma -lpmem -lprotobuf-c
  ENGINES += librpma_gpspm
endif
ifdef librpma_fio_SRCS
  SOURCE += $(librpma_fio_SRCS)
endif
ifdef CONFIG_POSIXAIO
  SOURCE += engines/posixaio.c
endif
ifdef CONFIG_LINUX_FALLOCATE
  SOURCE += engines/falloc.c
endif
ifdef CONFIG_LINUX_EXT4_MOVE_EXTENT
  SOURCE += engines/e4defrag.c
endif
ifdef CONFIG_LIBCUFILE
  SOURCE += engines/libcufile.c
endif
ifdef CONFIG_LINUX_SPLICE
  SOURCE += engines/splice.c
endif
ifdef CONFIG_SOLARISAIO
  SOURCE += engines/solarisaio.c
endif
ifdef CONFIG_WINDOWSAIO
  SOURCE += engines/windowsaio.c
endif
ifdef CONFIG_RADOS
  rados_SRCS = engines/rados.c
  rados_LIBS = -lrados
  ENGINES += rados
endif
ifdef CONFIG_RBD
  rbd_SRCS = engines/rbd.c
  rbd_LIBS = -lrbd -lrados
  ENGINES += rbd
endif
ifdef CONFIG_HTTP
  http_SRCS = engines/http.c
  http_LIBS = -lcurl -lssl -lcrypto
  ENGINES += http
endif
ifdef CONFIG_DFS
  dfs_SRCS = engines/dfs.c
  dfs_LIBS = -luuid -ldaos -ldfs
  ENGINES += dfs
endif
SOURCE += oslib/asprintf.c
ifndef CONFIG_STRSEP
  SOURCE += oslib/strsep.c
endif
ifndef CONFIG_STRCASESTR
  SOURCE += oslib/strcasestr.c
endif
ifndef CONFIG_STRLCAT
  SOURCE += oslib/strlcat.c
endif
ifndef CONFIG_HAVE_STRNDUP
  SOURCE += oslib/strndup.c
endif
ifndef CONFIG_GETOPT_LONG_ONLY
  SOURCE += oslib/getopt_long.c
endif
ifndef CONFIG_INET_ATON
  SOURCE += oslib/inet_aton.c
endif
ifndef CONFIG_HAVE_STATX
  SOURCE += oslib/statx.c
endif
ifdef CONFIG_GFAPI
  SOURCE += engines/glusterfs.c
  SOURCE += engines/glusterfs_sync.c
  SOURCE += engines/glusterfs_async.c
  LIBS += -lgfapi -lglusterfs
  ifdef CONFIG_GF_FADVISE
    FIO_CFLAGS += "-DGFAPI_USE_FADVISE"
  endif
endif
ifdef CONFIG_MTD
  SOURCE += engines/mtd.c
  SOURCE += oslib/libmtd.c
  SOURCE += oslib/libmtd_legacy.c
endif
ifdef CONFIG_PMEMBLK
  pmemblk_SRCS = engines/pmemblk.c
  pmemblk_LIBS = -lpmemblk
  ENGINES += pmemblk
endif
ifdef CONFIG_LINUX_DEVDAX
  dev-dax_SRCS = engines/dev-dax.c
  dev-dax_LIBS = -lpmem
  ENGINES += dev-dax
endif
ifdef CONFIG_LIBPMEM
  libpmem_SRCS = engines/libpmem.c
  libpmem_LIBS = -lpmem
  ENGINES += libpmem
endif
ifdef CONFIG_IME
  SOURCE += engines/ime.c
endif
ifdef CONFIG_LIBZBC
  libzbc_SRCS = engines/libzbc.c
  libzbc_LIBS = -lzbc
  ENGINES += libzbc
endif

ifeq ($(CONFIG_TARGET_OS), Linux)
  SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c engines/sg.c \
		oslib/linux-dev-lookup.c engines/io_uring.c
ifdef CONFIG_HAS_BLKZONED
  SOURCE += oslib/linux-blkzoned.c
endif
  LIBS += -lpthread -ldl
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), Android)
  SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c profiles/tiobench.c \
		oslib/linux-dev-lookup.c
ifdef CONFIG_HAS_BLKZONED
  SOURCE += oslib/linux-blkzoned.c
endif
  LIBS += -ldl -llog
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), SunOS)
  LIBS	 += -lpthread -ldl
  CPPFLAGS += -D__EXTENSIONS__
endif
ifeq ($(CONFIG_TARGET_OS), FreeBSD)
  SOURCE += trim.c
  LIBS	 += -lpthread -lrt
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), OpenBSD)
  LIBS	 += -lpthread
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), NetBSD)
  LIBS	 += -lpthread -lrt
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), DragonFly)
  SOURCE += trim.c
  LIBS	 += -lpthread -lrt
  LDFLAGS += -rdynamic
endif
ifeq ($(CONFIG_TARGET_OS), AIX)
  LIBS	 += -lpthread -ldl -lrt
  CPPFLAGS += -D_LARGE_FILES -D__ppc__
  LDFLAGS += -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000
endif
ifeq ($(CONFIG_TARGET_OS), HP-UX)
  LIBS   += -lpthread -ldl -lrt
  FIO_CFLAGS += -D_LARGEFILE64_SOURCE -D_XOPEN_SOURCE_EXTENDED
endif
ifeq ($(CONFIG_TARGET_OS), Darwin)
  LIBS	 += -lpthread -ldl
endif
ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
  SOURCE += os/windows/cpu-affinity.c os/windows/posix.c
  WINDOWS_OBJS = os/windows/cpu-affinity.o os/windows/posix.o lib/hweight.o
  LIBS	 += -lpthread -lpsapi -lws2_32 -lssp
  FIO_CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format
endif

ifdef CONFIG_DYNAMIC_ENGINES
 DYNAMIC_ENGS := $(ENGINES)
define engine_template =
$(1)_OBJS := $$($(1)_SRCS:.c=.o)
$$($(1)_OBJS): CFLAGS := -fPIC $$($(1)_CFLAGS) $(CFLAGS)
engines/fio-$(1).so: $$($(1)_OBJS)
	$$(QUIET_LINK)$(CC) -shared -rdynamic -fPIC -Wl,-soname,fio-$(1).so.1 -o $$@ $$< $$($(1)_LIBS)
ENGS_OBJS += engines/fio-$(1).so
endef
else # !CONFIG_DYNAMIC_ENGINES
define engine_template =
SOURCE += $$($(1)_SRCS)
LIBS += $$($(1)_LIBS)
override CFLAGS += $$($(1)_CFLAGS)
endef
endif

FIO-VERSION-FILE: FORCE
	@$(SHELL) $(SRCDIR)/FIO-VERSION-GEN
-include FIO-VERSION-FILE

override CFLAGS := -DFIO_VERSION='"$(FIO_VERSION)"' $(FIO_CFLAGS) $(CFLAGS)

$(foreach eng,$(ENGINES),$(eval $(call engine_template,$(eng))))

OBJS := $(SOURCE:.c=.o)

FIO_OBJS = $(OBJS) fio.o

GFIO_OBJS = $(OBJS) gfio.o graph.o tickmarks.o ghelpers.o goptions.o gerror.o \
			gclient.o gcompat.o cairo_text_helpers.o printing.o

ifdef CONFIG_ARITHMETIC
FIO_OBJS += lex.yy.o y.tab.o
GFIO_OBJS += lex.yy.o y.tab.o
endif

-include $(OBJS:.o=.d)

T_SMALLOC_OBJS = t/stest.o
T_SMALLOC_OBJS += gettime.o fio_sem.o pshared.o smalloc.o t/log.o t/debug.o \
		  t/arch.o
T_SMALLOC_PROGS = t/stest

T_IEEE_OBJS = t/ieee754.o
T_IEEE_OBJS += lib/ieee754.o
T_IEEE_PROGS = t/ieee754

T_ZIPF_OBS = t/genzipf.o
T_ZIPF_OBJS += t/log.o lib/ieee754.o lib/rand.o lib/pattern.o lib/zipf.o \
		lib/strntol.o lib/gauss.o t/genzipf.o oslib/strcasestr.o \
		oslib/strndup.o
T_ZIPF_PROGS = t/fio-genzipf

T_AXMAP_OBJS = t/axmap.o
T_AXMAP_OBJS += lib/lfsr.o lib/axmap.o
T_AXMAP_PROGS = t/axmap

T_LFSR_TEST_OBJS = t/lfsr-test.o
T_LFSR_TEST_OBJS += lib/lfsr.o gettime.o fio_sem.o pshared.o \
		    t/log.o t/debug.o t/arch.o
T_LFSR_TEST_PROGS = t/lfsr-test

T_GEN_RAND_OBJS = t/gen-rand.o
T_GEN_RAND_OBJS += t/log.o t/debug.o lib/rand.o lib/pattern.o lib/strntol.o \
			oslib/strcasestr.o oslib/strndup.o
T_GEN_RAND_PROGS = t/gen-rand

ifeq ($(CONFIG_TARGET_OS), Linux)
T_BTRACE_FIO_OBJS = t/btrace2fio.o
T_BTRACE_FIO_OBJS += fifo.o lib/flist_sort.o t/log.o oslib/linux-dev-lookup.o
T_BTRACE_FIO_PROGS = t/fio-btrace2fio
endif

T_DEDUPE_OBJS = t/dedupe.o
T_DEDUPE_OBJS += lib/rbtree.o t/log.o fio_sem.o pshared.o smalloc.o gettime.o \
		crc/md5.o lib/memalign.o lib/bloom.o t/debug.o crc/xxhash.o \
		t/arch.o crc/murmur3.o crc/crc32c.o crc/crc32c-intel.o \
		crc/crc32c-arm64.o crc/fnv.o
T_DEDUPE_PROGS = t/fio-dedupe

T_VS_OBJS = t/verify-state.o t/log.o crc/crc32c.o crc/crc32c-intel.o crc/crc32c-arm64.o t/debug.o
T_VS_PROGS = t/fio-verify-state

T_PIPE_ASYNC_OBJS = t/read-to-pipe-async.o
T_PIPE_ASYNC_PROGS = t/read-to-pipe-async

T_IOU_RING_OBJS = t/io_uring.o
T_IOU_RING_OBJS += t/arch.o
T_IOU_RING_PROGS = t/io_uring

T_MEMLOCK_OBJS = t/memlock.o
T_MEMLOCK_PROGS = t/memlock

T_TT_OBJS = t/time-test.o
T_TT_PROGS = t/time-test

T_FUZZ_OBJS = t/fuzz/fuzz_parseini.o
T_FUZZ_OBJS += $(OBJS)
ifdef CONFIG_ARITHMETIC
T_FUZZ_OBJS += lex.yy.o y.tab.o
endif
# in case there is no fuzz driver defined by environment variable LIB_FUZZING_ENGINE, use a simple one
# For instance, with compiler clang, address sanitizer and libFuzzer as a fuzzing engine, you should define
# export CFLAGS="-fsanitize=address,fuzzer-no-link"
# export LIB_FUZZING_ENGINE="-fsanitize=address"
# export CC=clang
# before running configure && make
# You can adapt this with different compilers, sanitizers, and fuzzing engines
ifndef LIB_FUZZING_ENGINE
T_FUZZ_OBJS += t/fuzz/onefile.o
endif
T_FUZZ_PROGS = t/fuzz/fuzz_parseini

T_OBJS = $(T_SMALLOC_OBJS)
T_OBJS += $(T_IEEE_OBJS)
T_OBJS += $(T_ZIPF_OBJS)
T_OBJS += $(T_AXMAP_OBJS)
T_OBJS += $(T_LFSR_TEST_OBJS)
T_OBJS += $(T_GEN_RAND_OBJS)
T_OBJS += $(T_BTRACE_FIO_OBJS)
T_OBJS += $(T_DEDUPE_OBJS)
T_OBJS += $(T_VS_OBJS)
T_OBJS += $(T_PIPE_ASYNC_OBJS)
T_OBJS += $(T_MEMLOCK_OBJS)
T_OBJS += $(T_TT_OBJS)
T_OBJS += $(T_IOU_RING_OBJS)
T_OBJS += $(T_FUZZ_OBJS)

ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
    T_DEDUPE_OBJS += $(WINDOWS_OBJS)
    T_SMALLOC_OBJS += $(WINDOWS_OBJS)
    T_LFSR_TEST_OBJS += $(WINDOWS_OBJS)
endif

T_TEST_PROGS = $(T_SMALLOC_PROGS)
T_TEST_PROGS += $(T_IEEE_PROGS)
T_PROGS += $(T_ZIPF_PROGS)
T_TEST_PROGS += $(T_AXMAP_PROGS)
T_TEST_PROGS += $(T_LFSR_TEST_PROGS)
T_TEST_PROGS += $(T_GEN_RAND_PROGS)
T_PROGS += $(T_BTRACE_FIO_PROGS)
T_PROGS += $(T_DEDUPE_PROGS)
T_PROGS += $(T_VS_PROGS)
T_TEST_PROGS += $(T_MEMLOCK_PROGS)
ifdef CONFIG_PREAD
T_TEST_PROGS += $(T_PIPE_ASYNC_PROGS)
endif
ifneq (,$(findstring Linux,$(CONFIG_TARGET_OS)))

=== debian/changelog ===
fio (3.28-1) unstable; urgency=medium

  * Imported new upstream version 3.28.
    Removes raw device support. (Closes: #997201)

 -- Sven Hoexter <hoexter@debian.org>  Thu, 28 Oct 2021 14:39:48 +0200

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el]
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/axboe/fio
Vcs-Git: https://salsa.debian.org/debian/fio.git
Vcs-Browser: https://salsa.debian.org/debian/fio

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: gnuplot, gfio, python-scipy
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the command line version of fio and all additional
 command line tools. The package gfio contains the GTK+ based gui frontend
 for fio.

Package: gfio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fio
Description: flexible I/O tester - gui frontend
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the GTK+ based gui frontend for fio. The package
 fio contains the command line version of fio which acts as a backend
 to the GUI frontend. The frontend can talk to a locally or remotely
 running fio server.

## fio 3.30

=== debian/changelog ===
fio (3.30-1) unstable; urgency=medium

  * Imported new upstream version 3.30 (Closes: #1009880).
  * docs: Install README.rst and HOWTO.rst instead of README and HOWTO.
  * control:
    * Add Sphinx as build-dependency in order to build manpage from it.
    * Bumped standards version to 4.6.0.1. No changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 20 Apr 2022 12:03:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el]
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el]
+Standards-Version: 4.6.0.1
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio
 Vcs-Git: https://salsa.debian.org/debian/fio.git

## fio 3.32

=== debian/changelog ===
fio (3.32-1) unstable; urgency=medium

  * Imported new upstream version 3.32 (Closes: #1022045).
  * control: Bumped standards version to 4.6.1. No changes needed.
  * copyright: Updated copyright years for files in "debian".
  * rules: Removed "-Wl,--as-needed". No need to support for a backport
    to Debian Buster anymore.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 24 Oct 2022 10:47:27 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el]
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio
 Vcs-Git: https://salsa.debian.org/debian/fio.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DEB_LDFLAGS_MAINT_PREPEND := -Wl,-z,defs

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export V = 1

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
export CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
endif

%:
	dh $@

override_dh_auto_configure:
	./configure --disable-native --prefix=/usr --enable-gfio

override_dh_installsystemd:
	dh_installsystemd --no-start --no-enable

override_dh_installinit:
	dh_installinit --no-start --no-enable

## fio 3.33

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 SCRIPTS = $(addprefix $(SRCDIR)/,tools/fio_generate_plots tools/plot/fio2gnuplot tools/genfio tools/fiologparser.py tools/hist/fiologparser_hist.py tools/hist/fio-histo-log-pctiles.py tools/fio_jsonplus_clat2csv)
 
 ifndef CONFIG_FIO_NO_OPT
-  FIO_CFLAGS += -O3 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
+  FIO_CFLAGS += -O3
 endif
 ifdef CONFIG_BUILD_NATIVE
   FIO_CFLAGS += -march=native
@@ -56,7 +56,7 @@
 		pshared.c options.c \
 		smalloc.c filehash.c profile.c debug.c engines/cpu.c \
 		engines/mmap.c engines/sync.c engines/null.c engines/net.c \
-		engines/ftruncate.c engines/filecreate.c engines/filestat.c engines/filedelete.c \
+		engines/ftruncate.c engines/fileoperations.c \
 		engines/exec.c \
 		server.c client.c iolog.c backend.c libfio.c flow.c cconv.c \
 		gettime-thread.c helpers.c json.c idletime.c td_error.c \
@@ -98,6 +98,8 @@
 endif
 ifdef CONFIG_LIBAIO
   libaio_SRCS = engines/libaio.c
+  cmdprio_SRCS = engines/cmdprio.c
+  LIBS += -laio
   libaio_LIBS = -laio
   ENGINES += libaio
 endif
@@ -109,13 +111,21 @@
 ifdef CONFIG_LIBRPMA_APM
   librpma_apm_SRCS = engines/librpma_apm.c
   librpma_fio_SRCS = engines/librpma_fio.c
-  librpma_apm_LIBS = -lrpma -lpmem
+  ifdef CONFIG_LIBPMEM2_INSTALLED
+    librpma_apm_LIBS = -lrpma -lpmem2
+  else
+    librpma_apm_LIBS = -lrpma -lpmem
+  endif
   ENGINES += librpma_apm
 endif
 ifdef CONFIG_LIBRPMA_GPSPM
   librpma_gpspm_SRCS = engines/librpma_gpspm.c engines/librpma_gpspm_flush.pb-c.c
   librpma_fio_SRCS = engines/librpma_fio.c
-  librpma_gpspm_LIBS = -lrpma -lpmem -lprotobuf-c
+  ifdef CONFIG_LIBPMEM2_INSTALLED
+    librpma_gpspm_LIBS = -lrpma -lpmem2 -lprotobuf-c
+  else
+    librpma_gpspm_LIBS = -lrpma -lpmem -lprotobuf-c
+  endif
   ENGINES += librpma_gpspm
 endif
 ifdef librpma_fio_SRCS
@@ -221,10 +231,16 @@
   libzbc_LIBS = -lzbc
   ENGINES += libzbc
 endif
-
+ifdef CONFIG_LIBXNVME
+  xnvme_SRCS = engines/xnvme.c
+  xnvme_LIBS = $(LIBXNVME_LIBS)
+  xnvme_CFLAGS = $(LIBXNVME_CFLAGS)
+  ENGINES += xnvme
+endif
 ifeq ($(CONFIG_TARGET_OS), Linux)
   SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c engines/sg.c \
-		oslib/linux-dev-lookup.c engines/io_uring.c
+		oslib/linux-dev-lookup.c engines/io_uring.c engines/nvme.c
+  cmdprio_SRCS = engines/cmdprio.c
 ifdef CONFIG_HAS_BLKZONED
   SOURCE += oslib/linux-blkzoned.c
 endif
@@ -233,7 +249,9 @@
 endif
 ifeq ($(CONFIG_TARGET_OS), Android)
   SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c profiles/tiobench.c \
-		oslib/linux-dev-lookup.c
+		oslib/linux-dev-lookup.c engines/io_uring.c engines/nvme.c \
+		engines/sg.c
+  cmdprio_SRCS = engines/cmdprio.c
 ifdef CONFIG_HAS_BLKZONED
   SOURCE += oslib/linux-blkzoned.c
 endif
@@ -275,10 +293,14 @@
   LIBS	 += -lpthread -ldl
 endif
 ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
-  SOURCE += os/windows/cpu-affinity.c os/windows/posix.c
-  WINDOWS_OBJS = os/windows/cpu-affinity.o os/windows/posix.o lib/hweight.o
+  SOURCE += os/windows/cpu-affinity.c os/windows/posix.c os/windows/dlls.c
+  WINDOWS_OBJS = os/windows/cpu-affinity.o os/windows/posix.o os/windows/dlls.o lib/hweight.o
   LIBS	 += -lpthread -lpsapi -lws2_32 -lssp
   FIO_CFLAGS += -DPSAPI_VERSION=1 -Ios/windows/posix/include -Wno-format
+endif
+
+ifdef cmdprio_SRCS
+  SOURCE += $(cmdprio_SRCS)
 endif
 
 ifdef CONFIG_DYNAMIC_ENGINES
@@ -287,7 +309,7 @@
 $(1)_OBJS := $$($(1)_SRCS:.c=.o)
 $$($(1)_OBJS): CFLAGS := -fPIC $$($(1)_CFLAGS) $(CFLAGS)
 engines/fio-$(1).so: $$($(1)_OBJS)
-	$$(QUIET_LINK)$(CC) -shared -rdynamic -fPIC -Wl,-soname,fio-$(1).so.1 -o $$@ $$< $$($(1)_LIBS)
+	$$(QUIET_LINK)$(CC) $(LDFLAGS) -shared -rdynamic -fPIC -Wl,-soname,fio-$(1).so.1 -o $$@ $$< $$($(1)_LIBS)
 ENGS_OBJS += engines/fio-$(1).so
 endef
 else # !CONFIG_DYNAMIC_ENGINES
@@ -368,8 +390,7 @@
 T_PIPE_ASYNC_OBJS = t/read-to-pipe-async.o
 T_PIPE_ASYNC_PROGS = t/read-to-pipe-async
 
-T_IOU_RING_OBJS = t/io_uring.o
-T_IOU_RING_OBJS += t/arch.o
+T_IOU_RING_OBJS = t/io_uring.o lib/rand.o lib/pattern.o lib/strntol.o
 T_IOU_RING_PROGS = t/io_uring
 
 T_MEMLOCK_OBJS = t/memlock.o
@@ -378,14 +399,16 @@
 T_TT_OBJS = t/time-test.o
 T_TT_PROGS = t/time-test
 
+ifneq (,$(findstring -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION,$(CFLAGS)))
 T_FUZZ_OBJS = t/fuzz/fuzz_parseini.o
 T_FUZZ_OBJS += $(OBJS)
 ifdef CONFIG_ARITHMETIC
 T_FUZZ_OBJS += lex.yy.o y.tab.o
 endif
+# For proper fio code teardown CFLAGS needs to include -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
 # in case there is no fuzz driver defined by environment variable LIB_FUZZING_ENGINE, use a simple one
 # For instance, with compiler clang, address sanitizer and libFuzzer as a fuzzing engine, you should define
-# export CFLAGS="-fsanitize=address,fuzzer-no-link"
+# export CFLAGS="-fsanitize=address,fuzzer-no-link -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION"
 # export LIB_FUZZING_ENGINE="-fsanitize=address"
 # export CC=clang
 # before running configure && make
@@ -394,39 +417,12 @@
 T_FUZZ_OBJS += t/fuzz/onefile.o
 endif
 T_FUZZ_PROGS = t/fuzz/fuzz_parseini
+else	# CFLAGS includes -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
+T_FUZZ_OBJS =
+T_FUZZ_PROGS =
+endif
 
 T_OBJS = $(T_SMALLOC_OBJS)
 T_OBJS += $(T_IEEE_OBJS)
 T_OBJS += $(T_ZIPF_OBJS)
 T_OBJS += $(T_AXMAP_OBJS)
-T_OBJS += $(T_LFSR_TEST_OBJS)
-T_OBJS += $(T_GEN_RAND_OBJS)
-T_OBJS += $(T_BTRACE_FIO_OBJS)
-T_OBJS += $(T_DEDUPE_OBJS)
-T_OBJS += $(T_VS_OBJS)
-T_OBJS += $(T_PIPE_ASYNC_OBJS)
-T_OBJS += $(T_MEMLOCK_OBJS)
-T_OBJS += $(T_TT_OBJS)
-T_OBJS += $(T_IOU_RING_OBJS)
-T_OBJS += $(T_FUZZ_OBJS)
-
-ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
-    T_DEDUPE_OBJS += $(WINDOWS_OBJS)
-    T_SMALLOC_OBJS += $(WINDOWS_OBJS)
-    T_LFSR_TEST_OBJS += $(WINDOWS_OBJS)
-endif
-
-T_TEST_PROGS = $(T_SMALLOC_PROGS)
-T_TEST_PROGS += $(T_IEEE_PROGS)
-T_PROGS += $(T_ZIPF_PROGS)
-T_TEST_PROGS += $(T_AXMAP_PROGS)
-T_TEST_PROGS += $(T_LFSR_TEST_PROGS)
-T_TEST_PROGS += $(T_GEN_RAND_PROGS)
-T_PROGS += $(T_BTRACE_FIO_PROGS)
-T_PROGS += $(T_DEDUPE_PROGS)
-T_PROGS += $(T_VS_PROGS)
-T_TEST_PROGS += $(T_MEMLOCK_PROGS)
-ifdef CONFIG_PREAD
-T_TEST_PROGS += $(T_PIPE_ASYNC_PROGS)
-endif
-ifneq (,$(findstring Linux,$(CONFIG_TARGET_OS)))

=== debian/changelog ===
fio (3.33-3) unstable; urgency=medium

  [ Sven Hoexter ]
  * control: Remove suggest for python-scipy. It was used in
    the original implementation of fiologparser.py. (LP: #1950003)
    Dropped upstream in commit f4042e41df95da9677220556c891ca6ba5649ec1

  [ Martin Steigerwald ]
  * control: Add Breaks+Replaces for fio version lower than 3.32-2 to
    fix update failures. Thanks to Andreas Beckmann for bug report
    (Closes: #1025371).

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 05 Dec 2022 11:07:42 +0100

fio (3.33-2) unstable; urgency=medium

  * control: Mark package fio-examples as Multi-Arch: foreign.
  * patches:
    * makefile-hardening: Readd part of the original patch I removed with
      commit d2242de28d9d0d2ea3a64849c9acc014b05b6318. The part for C pre
      processor build flags is still needed.
    * fio2gnuplot-manpage: Fixed in upstream commit
      aed4796b989d3b33f86fb3be6b915e532df2d59d.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 30 Nov 2022 10:38:05 +0100

fio (3.33-1) unstable; urgency=medium

  * Imported new upstream version 3.33.
  * control:
    * Recommend fio for package fio-examples to make clear what
      to install in order to run an example.
    * Drop versioned constraint on dpkg-dev, since it is not
      necessary anymore since Debian buster.
  * control and rules: Enable NBD support. Thanks to Christian Ehrhardt
    for initial merge request (Closes: #966222).
  * Fix wrong day of week for changelog entry 1.59-1. Thanks to
    Jelmer Vernooĳ.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 28 Nov 2022 11:47:27 +0100

fio (3.32-2) unstable; urgency=medium

  * control and docs: Put example job files and images into extra package
    to make it possible to only install them where needed.
  * control: Suggest package "fio-examples".
  * fio.docs: Add fiograph python script and configuration.
  * NEWS: Explain that example job files are now in package "fio-examples".
    These are generated by fiograph and visualize what the examples are
    doing. Thanks to Sven Hoexter for improvement of this explanation.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 23 Nov 2022 14:59:56 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el]
+Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el], libnbd-dev
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio
@@ -12,7 +12,7 @@
 Package: fio
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, python3
-Suggests: gnuplot, gfio, python-scipy
+Suggests: fio-examples, gnuplot, gfio
 Description: flexible I/O tester
  fio is a tool that will spawn a number of threads or processes doing a
  particular type of I/O action as specified by the user. fio takes a
@@ -23,12 +23,12 @@
  .
  This package contains the command line version of fio and all additional
  command line tools. The package gfio contains the GTK+ based gui frontend
- for fio.
+ for fio. The package fio-examples contains the example job files.
 
 Package: gfio
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: fio
+Suggests: fio, fio-examples
 Description: flexible I/O tester - gui frontend
  fio is a tool that will spawn a number of threads or processes doing a
  particular type of I/O action as specified by the user. fio takes a
@@ -41,3 +41,20 @@
  fio contains the command line version of fio which acts as a backend
  to the GUI frontend. The frontend can talk to a locally or remotely
  running fio server.
+
+Package: fio-examples
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Recommends: fio
+Replaces: fio (<< 3.32-2)
+Breaks: fio (<< 3.32-2)
+Description: flexible I/O tester - example job files
+ fio is a tool that will spawn a number of threads or processes doing a
+ particular type of I/O action as specified by the user. fio takes a
+ number of global parameters, each inherited by the thread unless
+ otherwise parameters given to them overriding that setting is given.
+ The typical use of fio is to write a job file matching the I/O load
+ one wants to simulate.
+ .
+ This package contains the example job files.

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	./configure --disable-native --prefix=/usr --enable-gfio
+	./configure --disable-native --prefix=/usr --enable-gfio --enable-libnbd
 
 override_dh_installsystemd:
 	dh_installsystemd --no-start --no-enable

=== debian/watch ===
version=4
opts=pgpmode=mangle
opts=pgpsigurlmangle=s/$/.asc/ https://brick.kernel.dk/snaps/fio-(\d.*)\.tar\.gz

## fio 3.35

=== debian/changelog ===
fio (3.35-2) unstable; urgency=medium

  * Restrict building with GlusterFS support to 64 bit architectures
    (amd64, arm64, ppc64el, ppc64, riscv64, mips64el, s390x, ia64, sparc64).
    (Closes: #1041995, also see bug #1039604) 

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 26 Jul 2023 10:27:36 +0200

fio (3.35-1) unstable; urgency=medium

  * Imported new upstream version 3.35.
  * control: Bumped standards version to 4.6.2. No changes needed.
  * copyright:
    * Removed years from Debian packaging copyright.
    * Updated my mail address in all places.
    * "engines/pmemblk.c" is gone.
    * Added "zbd.c", "zbd.h", "zbd_types.h", "oslib/blkzoned.h" and
      "oslib/linux-blkzoned.c".
    * Added "crc/sha3.c".
    * Added files in directory "engines" that I missed before.
    * Added files in directories "t" and "t/zbd".
    * Added "oslib/strlcat.c".
    * Added "unittests/unittest.c", "unittests/oslib/strcasestr.c", and
      "unittests/oslib/strsep.c".

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 04 Jul 2023 12:42:05 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
-Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev, libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el], libnbd-dev
-Standards-Version: 4.6.1
+Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev [amd64 arm64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64], libpmem-dev [amd64 arm64 ppc64el], libpmemblk-dev [amd64 arm64 ppc64el], libnbd-dev
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio
 Vcs-Git: https://salsa.debian.org/debian/fio.git

## fio 3.36

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 endif
 
 DEBUGFLAGS = -DFIO_INC_DEBUG
-CPPFLAGS= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -DFIO_INTERNAL $(DEBUGFLAGS)
+CPPFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -DFIO_INTERNAL $(DEBUGFLAGS)
 OPTFLAGS= -g -ffast-math
 FIO_CFLAGS= -std=gnu99 -Wwrite-strings -Wall -Wdeclaration-after-statement $(OPTFLAGS) $(EXTFLAGS) $(BUILD_CFLAGS) -I. -I$(SRCDIR)
 LIBS	+= -lm $(EXTLIBS)
@@ -62,7 +62,7 @@
 		gettime-thread.c helpers.c json.c idletime.c td_error.c \
 		profiles/tiobench.c profiles/act.c io_u_queue.c filelock.c \
 		workqueue.c rate-submit.c optgroup.c helper_thread.c \
-		steadystate.c zone-dist.c zbd.c dedupe.c
+		steadystate.c zone-dist.c zbd.c dedupe.c fdp.c
 
 ifdef CONFIG_LIBHDFS
   HDFSFLAGS= -I $(JAVA_HOME)/include -I $(JAVA_HOME)/include/linux -I $(FIO_LIBHDFS_INCLUDE)
@@ -208,11 +208,6 @@
   SOURCE += oslib/libmtd.c
   SOURCE += oslib/libmtd_legacy.c
 endif
-ifdef CONFIG_PMEMBLK
-  pmemblk_SRCS = engines/pmemblk.c
-  pmemblk_LIBS = -lpmemblk
-  ENGINES += pmemblk
-endif
 ifdef CONFIG_LINUX_DEVDAX
   dev-dax_SRCS = engines/dev-dax.c
   dev-dax_LIBS = -lpmem
@@ -236,6 +231,12 @@
   xnvme_LIBS = $(LIBXNVME_LIBS)
   xnvme_CFLAGS = $(LIBXNVME_CFLAGS)
   ENGINES += xnvme
+endif
+ifdef CONFIG_LIBBLKIO
+  libblkio_SRCS = engines/libblkio.c
+  libblkio_LIBS = $(LIBBLKIO_LIBS)
+  libblkio_CFLAGS = $(LIBBLKIO_CFLAGS)
+  ENGINES += libblkio
 endif
 ifeq ($(CONFIG_TARGET_OS), Linux)
   SOURCE += diskutil.c fifo.c blktrace.c cgroup.c trim.c engines/sg.c \
@@ -424,5 +425,3 @@
 
 T_OBJS = $(T_SMALLOC_OBJS)
 T_OBJS += $(T_IEEE_OBJS)
-T_OBJS += $(T_ZIPF_OBJS)
-T_OBJS += $(T_AXMAP_OBJS)

=== debian/changelog ===
fio (3.36-1ubuntu0.1) noble; urgency=medium

  * Fix crash on riscv64 (LP: #2086920)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 07 Nov 2024 17:55:46 +0100

fio (3.36-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:52:31 +1100

fio (3.36-1build1) noble; urgency=medium

  * No-change rebuild against librdmacm1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:12:37 +0000

fio (3.36-1) unstable; urgency=medium

  * Imported new upstream version 3.36.
  * patches: Removed patch makefile-hardening. Applied upstream.
  * NEWS: Explained the removal of gfio since fio 3.35-3 and mentioned
    an alternative.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 23 Oct 2023 11:47:12 +0200

fio (3.35-4) unstable; urgency=medium

  * Only build with librbd-dev on 64 bit architectures and as before on
    Linux (Closes: #1053167).

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 04 Oct 2023 15:29:11 +0200

fio (3.35-3) unstable; urgency=medium

  [ Bastian Germann ]
  * gfio will not be ported to gtk3 or later. So drop this gtk2 dependent
    package. (Closes: #967339)

  [ Martin Steigerwald ]
  * control: Drop libpmemblk from Build-Depends. Thanks to Adam Borowski for
    his merge request.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 12 Sep 2023 09:46:14 +0200

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	./configure --disable-native --prefix=/usr --enable-gfio --enable-libnbd
+	./configure --disable-native --prefix=/usr --enable-libnbd
 
 override_dh_installsystemd:
 	dh_installsystemd --no-start --no-enable

## fio 3.37

=== debian/changelog ===
fio (3.37-1) unstable; urgency=medium

  * Imported new upstream version 3.37 (Closes: #1059937).
  * Refreshed patches.
  * control:
    * Add build support for LoongArch64 (Closes: #1061728).
      Thanks to Dandan for providing a patch.
    * Bumped standards version to 4.7.0. No changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 09 Apr 2024 14:19:20 +0200

=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-amd64 linux-arm64 linux-loong64 linux-ppc64el linux-ppc64 linux-riscv64 linux-mips64el linux-s390x linux-ia64 linux-sparc64], libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev [amd64 arm64 loong64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64], libpmem-dev [amd64 arm64 ppc64el], libnbd-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/axboe/fio
Vcs-Git: https://salsa.debian.org/debian/fio.git
Vcs-Browser: https://salsa.debian.org/debian/fio

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: fio-examples, gnuplot
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the command line version of fio and all additional
 command line tools. The package fio-examples contains the example job files.

Package: fio-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fio
Replaces: fio (<< 3.32-2)
Breaks: fio (<< 3.32-2)
Description: flexible I/O tester - example job files
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the example job files.

## fio 3.38

=== Makefile ===
--- 
+++ 
@@ -62,7 +62,7 @@
 		gettime-thread.c helpers.c json.c idletime.c td_error.c \
 		profiles/tiobench.c profiles/act.c io_u_queue.c filelock.c \
 		workqueue.c rate-submit.c optgroup.c helper_thread.c \
-		steadystate.c zone-dist.c zbd.c dedupe.c fdp.c
+		steadystate.c zone-dist.c zbd.c dedupe.c dataplacement.c
 
 ifdef CONFIG_LIBHDFS
   HDFSFLAGS= -I $(JAVA_HOME)/include -I $(JAVA_HOME)/include/linux -I $(FIO_LIBHDFS_INCLUDE)
@@ -107,29 +107,6 @@
   rdma_SRCS = engines/rdma.c
   rdma_LIBS = -libverbs -lrdmacm
   ENGINES += rdma
-endif
-ifdef CONFIG_LIBRPMA_APM
-  librpma_apm_SRCS = engines/librpma_apm.c
-  librpma_fio_SRCS = engines/librpma_fio.c
-  ifdef CONFIG_LIBPMEM2_INSTALLED
-    librpma_apm_LIBS = -lrpma -lpmem2
-  else
-    librpma_apm_LIBS = -lrpma -lpmem
-  endif
-  ENGINES += librpma_apm
-endif
-ifdef CONFIG_LIBRPMA_GPSPM
-  librpma_gpspm_SRCS = engines/librpma_gpspm.c engines/librpma_gpspm_flush.pb-c.c
-  librpma_fio_SRCS = engines/librpma_fio.c
-  ifdef CONFIG_LIBPMEM2_INSTALLED
-    librpma_gpspm_LIBS = -lrpma -lpmem2 -lprotobuf-c
-  else
-    librpma_gpspm_LIBS = -lrpma -lpmem -lprotobuf-c
-  endif
-  ENGINES += librpma_gpspm
-endif
-ifdef librpma_fio_SRCS
-  SOURCE += $(librpma_fio_SRCS)
 endif
 ifdef CONFIG_POSIXAIO
   SOURCE += engines/posixaio.c
@@ -425,3 +402,27 @@
 
 T_OBJS = $(T_SMALLOC_OBJS)
 T_OBJS += $(T_IEEE_OBJS)
+T_OBJS += $(T_ZIPF_OBJS)
+T_OBJS += $(T_AXMAP_OBJS)
+T_OBJS += $(T_LFSR_TEST_OBJS)
+T_OBJS += $(T_GEN_RAND_OBJS)
+T_OBJS += $(T_BTRACE_FIO_OBJS)
+T_OBJS += $(T_DEDUPE_OBJS)
+T_OBJS += $(T_VS_OBJS)
+T_OBJS += $(T_PIPE_ASYNC_OBJS)
+T_OBJS += $(T_MEMLOCK_OBJS)
+T_OBJS += $(T_TT_OBJS)
+T_OBJS += $(T_IOU_RING_OBJS)
+T_OBJS += $(T_FUZZ_OBJS)
+
+ifneq (,$(findstring CYGWIN,$(CONFIG_TARGET_OS)))
+    T_DEDUPE_OBJS += $(WINDOWS_OBJS)
+    T_SMALLOC_OBJS += $(WINDOWS_OBJS)
+    T_LFSR_TEST_OBJS += $(WINDOWS_OBJS)
+endif
+
+T_TEST_PROGS = $(T_SMALLOC_PROGS)
+T_TEST_PROGS += $(T_IEEE_PROGS)
+T_PROGS += $(T_ZIPF_PROGS)
+T_TEST_PROGS += $(T_AXMAP_PROGS)
+T_TEST_PROGS += $(T_LFSR_TEST_PROGS)

=== debian/changelog ===
fio (3.38-1) unstable; urgency=medium

  * Imported new upstream version 3.38.
  * control: Enabled NFS engine. Thanks to Braiam for the report and the
    patch (Closes: #1084803).
  * copyright: RPMA engine has been removed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 14 Oct 2024 15:32:53 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
-Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-amd64 linux-arm64 linux-loong64 linux-ppc64el linux-ppc64 linux-riscv64 linux-mips64el linux-s390x linux-ia64 linux-sparc64], libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev [amd64 arm64 loong64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64], libpmem-dev [amd64 arm64 ppc64el], libnbd-dev
+Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-amd64 linux-arm64 linux-loong64 linux-ppc64el linux-ppc64 linux-riscv64 linux-mips64el linux-s390x linux-ia64 linux-sparc64], libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev [amd64 arm64 loong64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64], libpmem-dev [amd64 arm64 ppc64el], libnbd-dev, libnfs-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio

## fio 3.39

=== Makefile ===
--- 
+++ 
@@ -365,7 +365,7 @@
 T_VS_OBJS = t/verify-state.o t/log.o crc/crc32c.o crc/crc32c-intel.o crc/crc32c-arm64.o t/debug.o
 T_VS_PROGS = t/fio-verify-state
 
-T_PIPE_ASYNC_OBJS = t/read-to-pipe-async.o
+T_PIPE_ASYNC_OBJS = t/read-to-pipe-async.o t/log.o
 T_PIPE_ASYNC_PROGS = t/read-to-pipe-async
 
 T_IOU_RING_OBJS = t/io_uring.o lib/rand.o lib/pattern.o lib/strntol.o

=== debian/changelog ===
fio (3.39-1) unstable; urgency=medium

  * Imported new upstream version 3.39.
  * control: Bumped standards version to 4.7.2. No changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 18 Mar 2025 14:25:01 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
 Build-Depends: debhelper-compat (= 13), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-amd64 linux-arm64 linux-loong64 linux-ppc64el linux-ppc64 linux-riscv64 linux-mips64el linux-s390x linux-ia64 linux-sparc64], libcairo2-dev, libnuma-dev [linux-any], flex, bison, sphinx, python3-sphinx, libglusterfs-dev [amd64 arm64 loong64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64], libpmem-dev [amd64 arm64 ppc64el], libnbd-dev, libnfs-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/axboe/fio
 Vcs-Git: https://salsa.debian.org/debian/fio.git
